!
! Copyright (C) 1991-2004  ; All Rights Reserved ; Colorado State University
! Colorado State University Research Foundation ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================
!############################# Change Log ##################################
! 5.0.0
!
!###########################################################################

! Namelist reading routines for MODEL

subroutine nvfillm (group,vr,isub1,isub2,ii,ff,cc,nv)

use mem_all
use rpara

implicit none

! This routine places values read in for a particular NAMELIST
! variable in the storage location(s) for that variable
!
! GROUP   - NAMELIST group name
! VR      - NAMELIST variable name
! ISUB1   - value of first subscript
! ISUB2   - value of second subscript
! II      - vector of integer values
! FF      - vector of real values
! CC      - vector of character strings
! NV      - number of values to be inserted

character(len=*) group,vr,cc
real :: ff
integer :: isub1,isub2,ii,nv

integer :: nrflag,nfatal
common/nread/nrflag,nfatal

integer :: is1,inrflg

integer, parameter ::nvgrid=47,nvstrt=96,nvindat=53,nvprnt=16,nvsound=10
integer ::  igrids(nvgrid),istart(nvstrt),iindat(nvindat),iprnt(nvprnt)  &
         ,isound(nvsound)
character (len=16) :: grids(nvgrid),start(nvstrt),indat(nvindat),prnt(nvprnt)  &
           ,sound(nvsound)
data igrids/nvgrid*0/,istart/nvstrt*0/,iindat/nvindat*0/  &
    ,iprnt/nvprnt*0/,isound/nvsound*0/
DATA GRIDS/'EXPNME','RUNTYPE','TIMMAX','TIMEUNIT','NGRIDS'  &
     ,'NNXP','NNYP','NNZP','NZG','NZS','NXTNEST','IHTRAN'  &
     ,'DELTAX','DELTAY','DELTAZ','DZRAT','DZMAX','ZZ','IDELTAT'  &
     ,'DTLONG','NACOUST','IMONTH1','IDATE1','IYEAR1','ITIME1'  &
     ,'NSTRATX','NSTRATY','NSTRATZ1','NSTRATZ2','NINEST','NJNEST'  &
     ,'NESTZ1','NESTZ2','NKNEST','NNSTTOP','NNSTBOT','NNDTRAT'  &
     ,'POLELAT','POLELON','CENTLAT','CENTLON','GRIDU','GRIDV'  &
     ,'IF_ADAP','LOAD_BAL','STDLAT1','STDLAT2'/
DATA START/  &
      'INITIAL','VARFPFX','NUDLAT','TNUDLAT','TNUDCENT','TNUDTOP'  &
     ,'ZNUDTOP','HFILIN','IOUTPUT','AFILEPREF'  &
     ,'FRQSTATE','FRQSTATE_KEEP','FRQPRT','INITFLD','ICLOBBER'  &
     ,'SFCFILES','TOPFILES','SSTFPFX','NDVIFPFX','ITOPTFLG','ISSTFLG'   &
     ,'NDVIFLG','IVEGTFLG','ISOILFLG','NOFILFLG','IUPDSST'  &
     ,'IUPDNDVI','ITOPTFN','ISSTFN','NDVIFN','IVEGTFN'  &
     ,'ISOILFN','TOPTENH','TOPTWVL','MKCOLTAB','COLTABFN'  &
     ,'VWAIT1','VWAITTOT','AVGTIM','FRQLITE'  &
     ,'FRQMEAN','FRQBOTH','XLITE','YLITE','ZLITE','LITE_VARS'  &
     ,'ITOPSFLG','IZ0FLG','Z0MAX','Z0FACT','NLITE_VARS'  &
     ,'IPASTIN','PASTFN','NUD_TYPE' &
     ,'IF_ODA','ODA_UPAPREFIX','ODA_SFCPREFIX'  &
     ,'FRQODA','WT_ODA_GRID','TNUDODA'  &
     ,'WT_ODA_UV','WT_ODA_TH','WT_ODA_PI','WT_ODA_RT'  &
     ,'RODA_SFCE','RODA_SFC0','RODA_UPAE' &
     ,'RODA_UPA0','RODA_HGT','RODA_ZFACT','ODA_SFC_TIL','ODA_SFC_TEL' &
     ,'ODA_UPA_TIL','ODA_UPA_TEL','TODABEG','TODAEND'  &
     ,'IF_CUINV','CU_PREFIX','TCU_BEG','TCU_END','CU_TEL','CU_TIL' &
     ,'TNUDCU','WT_CU_GRID'  &
     ,'WT_NUDGE_UV','WT_NUDGE_TH','WT_NUDGE_PI','WT_NUDGE_RT'  &
     ,'T_NUDGE_RC','WT_NUDGE_GRID','NUD_COND','TCOND_BEG','TCOND_END'  &
     ,'WT_NUDGEC_GRID','NUD_HFILE','COND_HFILE'/
DATA INDAT/  &
      'NADDSC','ICORFLG','IBND','JBND','CPHAS','LSFLG','NFPT'  &
     ,'DISTIM','ISWRTYP','ILWRTYP','RADFRQ','LONRAD','NNQPARM'  &
     ,'CONFRQ','WCLDBS','NPATCH','NVEGPAT','ISFCL','NVGCON'  &
     ,'PCTLCON','NSLCON','ZROUGH','ALBEDO'  &
     ,'SEATMP','DTHCON','DRTCON','SLZ','SLMSTR','STGOFF'  &
     ,'IDIFFK','CSX','CSZ','XKHKM','ZKHKM','AKMIN','LEVEL'  &
     ,'ICLOUD','IRAIN','IPRIS','ISNOW','IAGGR','IGRAUP'  &
     ,'IHAIL','CPARM','RPARM','PPARM','SPARM','APARM','GPARM'  &
     ,'HPARM','GNU','IHORGRAD','IF_URBAN_CANOPY'/
DATA SOUND/  &
      'IPSFLG','ITSFLG','IRTSFLG','IUSFLG','HS','PS','TS','RTS','US','VS'/
DATA PRNT /  &
      'NPLT','IXSCTN','PLFMT','IPLFLD','ISBVAL'  &
     ,'PLTIT','IAA','IAB','JOA','JOB','NAAVG','NOAVG'  &
     ,'PLCONLO','PLCONHI','PLCONIN','IPLVECT'/


interface
   subroutine varsetf(c1,f1,i1,i2,f2,f3,f4)
   character(len=*) :: c1
   real :: f1,f2,f3,f4
   integer :: i1,i2
   end
   subroutine varseti(c1,i1,i2,i3,i4,i5,i6)
   character(len=*) :: c1
   integer :: i1,i2,i3,i4,i5,i6
   end
end interface


!print*,'vars:',GROUP,'---',VR

IS1=ISUB1
IF(ISUB1.EQ.0)IS1=NV

IF(GROUP.EQ.'$MODEL_GRIDS') THEN
  CALL VARCHK(VR,GROUP,GRIDS,IGRIDS,NVGRID,INRFLG)
  IF(INRFLG.EQ.1) RETURN
  IF(VR.EQ.'EXPNME')   CALL VARSETC(VR,EXPNME,IS1,1,CC,1,64)
  IF(VR.EQ.'RUNTYPE')  CALL VARSETC(VR,RUNTYPE,IS1,1,CC,1,16)
  IF(VR.EQ.'TIMMAX')   CALL VARSETF(VR,TIMMAX,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'TIMEUNIT') CALL VARSETC(VR,TIMEUNIT,IS1,1,CC,1,10)
  IF(VR.EQ.'IMONTH1')  CALL VARSETI(VR,IMONTH1,IS1,1,II,1,12)
  IF(VR.EQ.'IDATE1')   CALL VARSETI(VR,IDATE1,IS1,1,II,1,31)
  IF(VR.EQ.'IYEAR1')   CALL VARSETI(VR,IYEAR1,IS1,1,II,0,9999)
  IF(VR.EQ.'ITIME1')   CALL VARSETI(VR,ITIME1,IS1,1,II,0,2359)

  IF(VR.EQ.'IF_ADAP')  CALL VARSETI(VR,if_adap,IS1,1,II,0,1)
  IF(VR.EQ.'LOAD_BAL') CALL VARSETI(VR,load_bal,IS1,1,II,0,1)
  IF(VR.EQ.'NGRIDS')   CALL VARSETI(VR,NGRIDS,IS1,1,II,1,20)
  IF(VR.EQ.'NNXP')     CALL VARSETI(VR,NNXP(IS1),IS1,MAXGRDS,II,1,10000)
  IF(VR.EQ.'NNYP')     CALL VARSETI(VR,NNYP(IS1),IS1,MAXGRDS,II,1,10000)
  IF(VR.EQ.'NNZP')     CALL VARSETI(VR,NNZP(IS1),IS1,MAXGRDS,II,1,10000)
  IF(VR.EQ.'NZG')      CALL VARSETI(VR,NZG,IS1,1,II,1,10000)
  IF(VR.EQ.'NZS')      CALL VARSETI(VR,NZS,IS1,1,II,1,10000)
  IF(VR.EQ.'NXTNEST')  CALL VARSETI(VR,NXTNEST(IS1),IS1,MAXGRDS,II,0,20)
  IF(VR.EQ.'IHTRAN')   CALL VARSETI(VR,IHTRAN,IS1,1,II,0,2)
  IF(VR.EQ.'DELTAX')   CALL VARSETF(VR,DELTAX,IS1,1,FF,.001,1.E6)
  IF(VR.EQ.'DELTAY')   CALL VARSETF(VR,DELTAY,IS1,1,FF,.001,1.E6)
  IF(VR.EQ.'DELTAZ')   CALL VARSETF(VR,DELTAZ,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'DZRAT')    CALL VARSETF(VR,DZRAT,IS1,1,FF,.1,10.)
  IF(VR.EQ.'DZMAX')    CALL VARSETF(VR,DZMAX,IS1,1,FF,.001,1.E5)
  IF(VR.EQ.'ZZ')       CALL VARSETF(VR,ZZ(IS1),IS1,NZPMAX,FF,0.,1.E6)

  IF(VR.EQ.'IDELTAT')  CALL VARSETI(VR,IDELTAT,IS1,1,II,-5,5)
  IF(VR.EQ.'DTLONG')   CALL VARSETF(VR,DTLONG,IS1,1,FF,0.,1.E8)
  IF(VR.EQ.'NACOUST')  CALL VARSETI(VR,NACOUST,IS1,1,II,1,20)

  IF(VR.EQ.'CENTLAT')  CALL VARSETF(VR,CENTLAT(IS1),IS1,MAXGRDS,FF,-90.,90.)
  IF(VR.EQ.'CENTLON')  CALL VARSETF(VR,CENTLON(IS1),IS1,MAXGRDS,FF,-180.,180.)
  IF(VR.EQ.'POLELAT')  CALL VARSETF(VR,POLELAT,IS1,1,FF,-90.,90.)
  IF(VR.EQ.'POLELON')  CALL VARSETF(VR,POLELON,IS1,1,FF,-180.,180.)
  IF(VR.EQ.'STDLAT1')  CALL VARSETF(VR,STDLAT1,IS1,1,FF,-90.,90.)
  IF(VR.EQ.'STDLAT2')  CALL VARSETF(VR,STDLAT2,IS1,1,FF,-90.,90.)

  IF(VR.EQ.'NSTRATX')  CALL VARSETI(VR,NSTRATX(IS1),IS1,MAXGRDS,II,1,20)
  IF(VR.EQ.'NSTRATY')  CALL VARSETI(VR,NSTRATY(IS1),IS1,MAXGRDS,II,1,20)
  IF(VR.EQ.'NSTRATZ1') CALL VARSETI(VR,NSTRATZ1(IS1),IS1,NZPMAX,II,1,10)
  IF(VR.EQ.'NSTRATZ2') CALL VARSETI(VR,NSTRATZ2(IS1),IS1,NZPMAX,II,1,10)
  IF(VR.EQ.'NESTZ1')   CALL VARSETI(VR,NESTZ1,IS1,1,II,-100,100)
  IF(VR.EQ.'NESTZ2')   CALL VARSETI(VR,NESTZ2,IS1,1,II,-100,100)
  IF(VR.EQ.'NNDTRAT')  CALL VARSETI(VR,NNDTRAT(IS1),IS1,MAXGRDS,II,0,20)
  IF(VR.EQ.'NINEST')   CALL VARSETI(VR,NINEST(IS1),IS1,MAXGRDS,II,0,10000)
  IF(VR.EQ.'NJNEST')   CALL VARSETI(VR,NJNEST(IS1),IS1,MAXGRDS,II,0,10000)
  IF(VR.EQ.'NKNEST')   CALL VARSETI(VR,NKNEST(IS1),IS1,MAXGRDS,II,1,10000)
  IF(VR.EQ.'GRIDU')    CALL VARSETF(VR,GRIDU(IS1),IS1,MAXGRDS,FF,-2.e2,2.E2)
  IF(VR.EQ.'GRIDV')    CALL VARSETF(VR,GRIDV(IS1),IS1,MAXGRDS,FF,-2.e2,2.E2)
  IF(VR.EQ.'NNSTTOP')  CALL VARSETI(VR,NNSTTOP(IS1),IS1,MAXGRDS,II,0,1)
  IF(VR.EQ.'NNSTBOT')  CALL VARSETI(VR,NNSTBOT(IS1),IS1,MAXGRDS,II,0,1)
ENDIF

IF(GROUP.EQ.'$MODEL_FILE_INFO') THEN
  CALL VARCHK(VR,GROUP,START,ISTART,NVSTRT,INRFLG)
  IF(INRFLG.EQ.1) RETURN
  IF(VR.EQ.'INITIAL')  CALL VARSETI(VR,INITIAL,IS1,1,II,1,3)
  IF(VR.EQ.'VARFPFX')  CALL VARSETC(VR,VARFPFX,IS1,1,CC,1,80)
  IF(VR.EQ.'VWAIT1')   CALL VARSETF(VR,VWAIT1,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'VWAITTOT') CALL VARSETF(VR,VWAITTOT,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'NUDLAT')   CALL VARSETI(VR,NUDLAT,IS1,1,II,0,10000)
  IF(VR.EQ.'TNUDLAT')  CALL VARSETF(VR,TNUDLAT,IS1,1,FF,0.,1.e10)
  IF(VR.EQ.'TNUDCENT') CALL VARSETF(VR,TNUDCENT,IS1,1,FF,0.,1.e10)
  IF(VR.EQ.'TNUDTOP')  CALL VARSETF(VR,TNUDTOP,IS1,1,FF,0.,1.e10)
  IF(VR.EQ.'ZNUDTOP')  CALL VARSETF(VR,ZNUDTOP,IS1,1,FF,0.,1.e10)
  IF(VR.EQ.'HFILIN')   CALL VARSETC(VR,HFILIN,IS1,1,CC,1,80)
  IF(VR.EQ.'IOUTPUT')  CALL VARSETI(VR,IOUTPUT,IS1,1,II,0,2)
  IF(VR.EQ.'ICLOBBER') CALL VARSETI(VR,ICLOBBER,IS1,1,II,0,1)
  IF(VR.EQ.'AFILEPREF')  CALL VARSETC(VR,AFILEPREF,IS1,1,CC,1,80)
  IF(VR.EQ.'FRQSTATE') CALL VARSETF(VR,FRQSTATE(IS1),IS1,MAXGRDS,FF,0.,1.E20)
  IF(VR.EQ.'FRQSTATE_KEEP')  CALL VARSETF(VR,FRQSTATE_KEEP,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'FRQLITE')  CALL VARSETF(VR,FRQLITE,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'FRQMEAN')  CALL VARSETF(VR,FRQMEAN,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'FRQBOTH')  CALL VARSETF(VR,FRQBOTH,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'AVGTIM')   CALL VARSETF(VR,AVGTIM,IS1,1,FF,-1.E20,1.E20)
  IF(VR.EQ.'XLITE')    CALL VARSETC(VR,XLITE,IS1,1,CC,1,20)
  IF(VR.EQ.'YLITE')    CALL VARSETC(VR,YLITE,IS1,1,CC,1,20)
  IF(VR.EQ.'ZLITE')    CALL VARSETC(VR,ZLITE,IS1,1,CC,1,20)
  IF(VR.EQ.'NLITE_VARS')CALL VARSETI(VR,NLITE_VARS,IS1,1,II,0,MAXLITE)
  IF(VR.EQ.'LITE_VARS')CALL VARSETC(VR,LITE_VARS(IS1),IS1,MAXLITE,CC,1,32)
  IF(VR.EQ.'FRQPRT')   CALL VARSETF(VR,FRQPRT,IS1,1,FF,.001,1.E20)
  IF(VR.EQ.'INITFLD')  CALL VARSETI(VR,INITFLD,IS1,1,II,0,1)
  IF(VR.EQ.'SFCFILES') CALL VARSETC(VR,SFCFILES,IS1,1,CC,1,80)
  IF(VR.EQ.'TOPFILES') CALL VARSETC(VR,TOPFILES,IS1,1,CC,1,80)
  IF(VR.EQ.'SSTFPFX')  CALL VARSETC(VR,SSTFPFX,IS1,1,CC,1,80)
  IF(VR.EQ.'NDVIFPFX') CALL VARSETC(VR,NDVIFPFX,IS1,1,CC,1,80)
  IF(VR.EQ.'ITOPTFLG') CALL VARSETI(VR,ITOPTFLG(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'ISSTFLG')  CALL VARSETI(VR,ISSTFLG(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'IVEGTFLG') CALL VARSETI(VR,IVEGTFLG(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'ISOILFLG') CALL VARSETI(VR,ISOILFLG(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'NDVIFLG')  CALL VARSETI(VR,NDVIFLG(IS1),IS1,MAXGRDS,II,0,3)
  IF(VR.EQ.'NOFILFLG') CALL VARSETI(VR,NOFILFLG(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'IUPDSST')  CALL VARSETI(VR,IUPDSST,IS1,1,II,0,2)
  IF(VR.EQ.'IUPDNDVI') CALL VARSETI(VR,IUPDNDVI,IS1,1,II,0,2)
  IF(VR.EQ.'ITOPTFN')  CALL VARSETC(VR,ITOPTFN(IS1),IS1,MAXGRDS,CC,1,80)
  IF(VR.EQ.'ISSTFN')   CALL VARSETC(VR,ISSTFN(IS1),IS1,MAXGRDS,CC,1,80)
  IF(VR.EQ.'IVEGTFN')  CALL VARSETC(VR,IVEGTFN(IS1),IS1,MAXGRDS,CC,1,80)
  IF(VR.EQ.'ISOILFN')  CALL VARSETC(VR,ISOILFN(IS1),IS1,MAXGRDS,CC,1,80)
  IF(VR.EQ.'NDVIFN')   CALL VARSETC(VR,NDVIFN(IS1),IS1,MAXGRDS,CC,1,80)
  IF(VR.EQ.'TOPTENH')  CALL VARSETF(VR,TOPTENH(IS1),IS1,MAXGRDS,FF,0.,5.)
  IF(VR.EQ.'ITOPSFLG') CALL VARSETI(VR,ITOPSFLG(IS1),IS1,MAXGRDS,II,0,3)
  IF(VR.EQ.'IZ0FLG')   CALL VARSETI(VR,IZ0FLG(IS1),IS1,MAXGRDS,II,0,1)
  IF(VR.EQ.'Z0MAX')    CALL VARSETF(VR,Z0MAX(IS1),IS1,MAXGRDS,FF,0.,20.)
  IF(VR.EQ.'Z0FACT')   CALL VARSETF(VR,Z0FACT,IS1,1,FF,.0001,.1)
  IF(VR.EQ.'TOPTWVL')  CALL VARSETF(VR,TOPTWVL(IS1),IS1,MAXGRDS,FF,2.,9.)
  IF(VR.EQ.'MKCOLTAB') CALL VARSETI(VR,MKCOLTAB,IS1,1,II,0,1)
  IF(VR.EQ.'COLTABFN') CALL VARSETC(VR,COLTABFN,IS1,1,CC,1,80)
  IF(VR.EQ.'IPASTIN')  CALL VARSETI(VR,IPASTIN,IS1,1,II,0,1)
  IF(VR.EQ.'PASTFN')   CALL VARSETC(VR,PASTFN,IS1,1,CC,1,80)
  IF(VR.EQ.'NUD_TYPE')   CALL VARSETI(VR,NUD_TYPE,IS1,1,II,0,2)
  IF(VR.EQ.'IF_ODA')   CALL VARSETI(VR,IF_ODA,IS1,1,II,0,1)
  IF(VR.EQ.'ODA_UPAPREFIX')   CALL VARSETC(VR,ODA_UPAPREFIX,IS1,1,CC,1,128)
  IF(VR.EQ.'ODA_SFCPREFIX')   CALL VARSETC(VR,ODA_SFCPREFIX,IS1,1,CC,1,128)
  IF(VR.EQ.'FRQODA')  CALL VARSETF(VR,FRQODA,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'WT_ODA_GRID')   &
                      CALL VARSETF(VR,WT_ODA_GRID(IS1),IS1,MAXGRDS,FF,0.,10.)
  IF(VR.EQ.'TNUDODA')   CALL VARSETF(VR,TNUDODA,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'WT_ODA_UV')  CALL VARSETF(VR,WT_ODA_UV,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_ODA_TH')  CALL VARSETF(VR,WT_ODA_TH,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_ODA_PI')  CALL VARSETF(VR,WT_ODA_PI,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_ODA_RT')  CALL VARSETF(VR,WT_ODA_RT,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'RODA_SFCE')   CALL VARSETF(VR,RODA_SFCE(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'RODA_SFC0')   CALL VARSETF(VR,RODA_SFC0(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'RODA_UPAE')   CALL VARSETF(VR,RODA_UPAE(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'RODA_UPA0')   CALL VARSETF(VR,RODA_UPA0(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'RODA_HGT')   CALL VARSETF(VR,RODA_HGT(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'RODA_ZFACT')   CALL VARSETF(VR,RODA_ZFACT(IS1),IS1,MAXGRDS,FF,1.,1.e20)
  IF(VR.EQ.'ODA_SFC_TIL')  CALL VARSETF(VR,ODA_SFC_TIL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'ODA_SFC_TEL')  CALL VARSETF(VR,ODA_SFC_TEL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'ODA_UPA_TIL')  CALL VARSETF(VR,ODA_UPA_TIL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'ODA_UPA_TEL')  CALL VARSETF(VR,ODA_UPA_TEL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'TODABEG')  CALL VARSETF(VR,TODABEG,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'TODAEND')  CALL VARSETF(VR,TODAEND,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'IF_CUINV')   CALL VARSETI(VR,IF_CUINV,IS1,1,II,0,1)
  IF(VR.EQ.'CU_PREFIX')   CALL VARSETC(VR,CU_PREFIX,IS1,1,CC,1,128)
  IF(VR.EQ.'TCU_BEG')  CALL VARSETF(VR,TCU_BEG,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'TCU_END')  CALL VARSETF(VR,TCU_END,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'CU_TIL')  CALL VARSETF(VR,CU_TIL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'CU_TEL')  CALL VARSETF(VR,CU_TEL,IS1,1,FF,0.,1.E20)
  IF(VR.EQ.'TNUDCU')   CALL VARSETF(VR,TNUDCU,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'WT_CU_GRID')   &
                      CALL VARSETF(VR,WT_CU_GRID(IS1),IS1,MAXGRDS,FF,0.,10.)
  IF(VR.EQ.'WT_NUDGE_UV')  CALL VARSETF(VR,WT_NUDGE_UV,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_NUDGE_TH')  CALL VARSETF(VR,WT_NUDGE_TH,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_NUDGE_PI')  CALL VARSETF(VR,WT_NUDGE_PI,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_NUDGE_RT')  CALL VARSETF(VR,WT_NUDGE_RT,IS1,1,FF,0.,10.0)
  IF(VR.EQ.'WT_NUDGE_GRID')  &
                       CALL VARSETF(VR,WT_NUDGE_GRID(IS1),IS1,MAXGRDS,FF,0.,10.0)
  IF(VR.EQ.'NUD_COND')     CALL VARSETI(VR,NUD_COND,IS1,1,II,0,1)
  IF(VR.EQ.'NUD_HFILE')  CALL VARSETC(VR,NUD_HFILE,IS1,1,CC,1,128)
  IF(VR.EQ.'COND_HFILE')  CALL VARSETC(VR,COND_HFILE,IS1,1,CC,1,128)
  IF(VR.EQ.'T_NUDGE_RC')  CALL VARSETF(VR,T_NUDGE_RC,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'TCOND_BEG')  CALL VARSETF(VR,TCOND_BEG,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'TCOND_END')  CALL VARSETF(VR,TCOND_END,IS1,1,FF,0.,1.e20)
  IF(VR.EQ.'WT_NUDGEC_GRID')  &
                       CALL VARSETF(VR,WT_NUDGEC_GRID(IS1),IS1,MAXGRDS,FF,0.,1.e20)
ENDIF

IF(GROUP.EQ.'$MODEL_OPTIONS') THEN
  CALL VARCHK(VR,GROUP,INDAT,IINDAT,NVINDAT,INRFLG)
  IF(INRFLG.EQ.1) RETURN
  IF(VR.EQ.'NADDSC')   CALL VARSETI(VR,NADDSC,IS1,1,II,0,500)
  IF(VR.EQ.'ICORFLG')  CALL VARSETI(VR,ICORFLG,IS1,1,II,0,1)
  IF(VR.EQ.'IBND')     CALL VARSETI(VR,IBND,IS1,1,II,1,4)
  IF(VR.EQ.'JBND')     CALL VARSETI(VR,JBND,IS1,1,II,1,4)
  IF(VR.EQ.'CPHAS')    CALL VARSETF(VR,CPHAS,IS1,1,FF,.001,1.E8)
  IF(VR.EQ.'LSFLG')    CALL VARSETI(VR,LSFLG,IS1,1,II,0,3)
  IF(VR.EQ.'NFPT')     CALL VARSETI(VR,NFPT,IS1,1,II,0,10000)
  IF(VR.EQ.'DISTIM')   CALL VARSETF(VR,DISTIM,IS1,1,FF,0.,10000.)
  IF(VR.EQ.'ISWRTYP')  CALL VARSETI(VR,ISWRTYP,IS1,1,II,0,3)
  IF(VR.EQ.'ILWRTYP')  CALL VARSETI(VR,ILWRTYP,IS1,1,II,0,3)
  IF(VR.EQ.'RADFRQ')   CALL VARSETF(VR,RADFRQ,IS1,1,FF,.001,100000.)
  IF(VR.EQ.'LONRAD')   CALL VARSETI(VR,LONRAD,IS1,1,II,0,1)
  IF(VR.EQ.'NNQPARM')  CALL VARSETI(VR,NNQPARM(IS1),IS1,MAXGRDS,II,0,2)
  IF(VR.EQ.'CONFRQ')   CALL VARSETF(VR,CONFRQ,IS1,1,FF,.001,100000.)
  IF(VR.EQ.'WCLDBS')   CALL VARSETF(VR,WCLDBS,IS1,1,FF,-10.,10.)
  IF(VR.EQ.'NPATCH')   CALL VARSETI(VR,NPATCH,IS1,1,II,2,10)
  IF(VR.EQ.'NVEGPAT')  CALL VARSETI(VR,NVEGPAT,IS1,1,II,1,10)
  IF(VR.EQ.'ISFCL')    CALL VARSETI(VR,ISFCL,IS1,1,II,0,2)
  IF(VR.EQ.'NVGCON')   CALL VARSETI(VR,NVGCON,IS1,1,II,0,30)
  IF(VR.EQ.'PCTLCON')  CALL VARSETF(VR,PCTLCON,IS1,1,FF,0.,1.)
  IF(VR.EQ.'NSLCON')   CALL VARSETI(VR,NSLCON,IS1,1,II,1,12)
  IF(VR.EQ.'ZROUGH')   CALL VARSETF(VR,ZROUGH,IS1,1,FF,.0001,100.)
  IF(VR.EQ.'ALBEDO')   CALL VARSETF(VR,ALBEDO,IS1,1,FF,0.,1.)
  IF(VR.EQ.'SEATMP')   CALL VARSETF(VR,SEATMP,IS1,1,FF,100.,500.)
  IF(VR.EQ.'DTHCON')   CALL VARSETF(VR,DTHCON,IS1,1,FF,-100.,100.)
  IF(VR.EQ.'DRTCON')   CALL VARSETF(VR,DRTCON,IS1,1,FF,-1.,1.)
  IF(VR.EQ.'SLZ')      CALL VARSETF(VR,SLZ(IS1),IS1,NZGMAX,FF,-1.E5,0.)
  IF(VR.EQ.'SLMSTR')   CALL VARSETF(VR,SLMSTR(IS1),IS1,NZGMAX,FF,0.,1.)
  IF(VR.EQ.'STGOFF')   CALL VARSETF(VR,STGOFF(IS1),IS1,NZGMAX,FF,-50.,50.)
  IF(VR.EQ.'IDIFFK')   CALL VARSETI(VR,IDIFFK(IS1),IS1,MAXGRDS,II,1,6)
  IF(VR.EQ.'IHORGRAD') CALL VARSETI(VR,IHORGRAD,IS1,1,II,1,2)
  IF(VR.EQ.'CSX')      CALL VARSETF(VR,CSX(IS1),IS1,MAXGRDS,FF,0.,10.)
  IF(VR.EQ.'CSZ')      CALL VARSETF(VR,CSZ(IS1),IS1,MAXGRDS,FF,0.,10.)
  IF(VR.EQ.'XKHKM')    CALL VARSETF(VR,XKHKM(IS1),IS1,MAXGRDS,FF,0.,100.)
  IF(VR.EQ.'ZKHKM')    CALL VARSETF(VR,ZKHKM(IS1),IS1,MAXGRDS,FF,0.,100.)
  IF(VR.EQ.'AKMIN')    CALL VARSETF(VR,AKMIN(IS1),IS1,MAXGRDS,FF,0.,5.)
  IF(VR.EQ.'LEVEL')    CALL VARSETI(VR,LEVEL,IS1,1,II,0,3)
  IF(VR.EQ.'ICLOUD')   CALL VARSETI(VR,ICLOUD,IS1,1,II,0,7)
  IF(VR.EQ.'IRAIN')    CALL VARSETI(VR,IRAIN,IS1,1,II,0,5)
  IF(VR.EQ.'IPRIS')    CALL VARSETI(VR,IPRIS,IS1,1,II,0,7)
  IF(VR.EQ.'ISNOW')    CALL VARSETI(VR,ISNOW,IS1,1,II,0,5)
  IF(VR.EQ.'IAGGR')    CALL VARSETI(VR,IAGGR,IS1,1,II,0,5)
  IF(VR.EQ.'IGRAUP')   CALL VARSETI(VR,IGRAUP,IS1,1,II,0,5)
  IF(VR.EQ.'IHAIL')    CALL VARSETI(VR,IHAIL,IS1,1,II,0,5)
  IF(VR.EQ.'CPARM')    CALL VARSETF(VR,CPARM,IS1,1,FF,0.,1.E10)
  IF(VR.EQ.'RPARM')    CALL VARSETF(VR,RPARM,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'PPARM')    CALL VARSETF(VR,PPARM,IS1,1,FF,0.,1.E8)
  IF(VR.EQ.'SPARM')    CALL VARSETF(VR,SPARM,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'APARM')    CALL VARSETF(VR,APARM,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'GPARM')    CALL VARSETF(VR,GPARM,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'HPARM')    CALL VARSETF(VR,HPARM,IS1,1,FF,0.,1.E5)
  IF(VR.EQ.'GNU')      CALL VARSETF(VR,GNU(IS1),IS1,7,FF,0.,20.)
  IF(VR.EQ.'IF_URBAN_CANOPY') CALL VARSETI(VR,IF_URBAN_CANOPY,IS1,1,II,0,1)
ENDIF

IF(GROUP.EQ.'$MODEL_SOUND') THEN
  CALL VARCHK(VR,GROUP,SOUND,ISOUND,NVSOUND,INRFLG)
  IF(INRFLG.EQ.1) RETURN
  IF(VR.EQ.'PS')      CALL VARSETF(VR,PS(IS1),IS1,MAXSNDG,FF,0.,1.E7)
  IF(VR.EQ.'HS')      CALL VARSETF(VR,HS(IS1),IS1,MAXSNDG,FF,-1.e3,1.E5)
  IF(VR.EQ.'TS')      CALL VARSETF(VR,TS(IS1),IS1,MAXSNDG,FF,-200.,1000.)
  IF(VR.EQ.'RTS')     CALL VARSETF(VR,RTS(IS1),IS1,MAXSNDG,FF,-200.,1000.)
  IF(VR.EQ.'US')      CALL VARSETF(VR,US(IS1),IS1,MAXSNDG,FF,-500.,500.)
  IF(VR.EQ.'VS')      CALL VARSETF(VR,VS(IS1),IS1,MAXSNDG,FF,-500.,500.)
  IF(VR.EQ.'IPSFLG')  CALL VARSETI(VR,IPSFLG,IS1,1,II,0,10)
  IF(VR.EQ.'ITSFLG')  CALL VARSETI(VR,ITSFLG,IS1,1,II,0,10)
  IF(VR.EQ.'IRTSFLG') CALL VARSETI(VR,IRTSFLG,IS1,1,II,0,10)
  IF(VR.EQ.'IUSFLG')  CALL VARSETI(VR,IUSFLG,IS1,1,II,0,10)
ENDIF

IF(GROUP.EQ.'$MODEL_PRINT')THEN
  CALL VARCHK(VR,GROUP,PRNT,IPRNT,NVPRNT,INRFLG)
  IF(INRFLG.EQ.1) RETURN
  IF(VR.EQ.'NPLT')    CALL VARSETI(VR,NPLT,IS1,1,II,0,50)
  IF(VR.EQ.'IXSCTN')  CALL VARSETI(VR,IXSCTN(IS1),IS1,50,II,1,3)
  IF(VR.EQ.'IPLFLD')  CALL VARSETC(VR,IPLFLD(IS1),IS1,50,CC,1,16)
  IF(VR.EQ.'ISBVAL')  CALL VARSETI(VR,ISBVAL(IS1),IS1,50,II,1,10000)
  IF(VR.EQ.'IAA')     CALL VARSETI(VR,IAA(IS1),IS1,50,II,-10000,0)
  IF(VR.EQ.'IAB')     CALL VARSETI(VR,IAB(IS1),IS1,50,II,-10000,0)
  IF(VR.EQ.'JOA')     CALL VARSETI(VR,JOA(IS1),IS1,50,II,-10000,0)
  IF(VR.EQ.'JOB')     CALL VARSETI(VR,JOB(IS1),IS1,50,II,-10000,0)
  IF(VR.EQ.'NAAVG')   CALL VARSETI(VR,NAAVG(IS1),IS1,50,II,1,1000)
  IF(VR.EQ.'NOAVG')   CALL VARSETI(VR,NOAVG(IS1),IS1,50,II,1,1000)
  IF(VR.EQ.'PLFMT')   CALL VARSETC(VR,PLFMT(IS1),IS1,50,CC,0,8)
  IF(VR.EQ.'PLTIT')   CALL VARSETC(VR,PLTIT(IS1),IS1,50,CC,0,16)
  IF(VR.EQ.'PLCONLO') CALL VARSETF(VR,PLCONLO(IS1),IS1,50,FF,-1.E10,1.E10)
  IF(VR.EQ.'PLCONHI') CALL VARSETF(VR,PLCONHI(IS1),IS1,50,FF,-1.E10,1.E10)
  IF(VR.EQ.'PLCONIN') CALL VARSETF(VR,PLCONIN(IS1),IS1,50,FF,-100.,1.E10)
  IF(VR.EQ.'IPLVECT') CALL VARSETI(VR,IPLVECT(IS1),IS1,50,II,0,100)
ENDIF

RETURN
END

!*******************************************************************************

SUBROUTINE NAMEOUT

use mem_all

implicit none

integer :: ng,np,k,m

! This routine prints out a listing of the values of all variables
! in the NAMELISTS

WRITE(6,100)
100  FORMAT(/,'----------------------------NAMELIST VARIABLES-------'  &
      ,'------------------------',/)
WRITE(6,101)(' ',NNXP(NG),NNYP(NG),NNZP(NG)  &
            ,NXTNEST(NG),NSTRATX(NG),NG=1,NGRIDS)
WRITE(6,102)(' ',NSTRATY(NG),IDIFFK(NG),NNDTRAT(NG)  &
            ,NNQPARM(NG),NINEST(NG),NG=1,NGRIDS)
WRITE(6,103)(' ',NJNEST(NG),NKNEST(NG),NNSTTOP(NG)  &
            ,NNSTBOT(NG),ITOPTFLG(NG),NG=1,NGRIDS)
WRITE(6,104)(' ',ISSTFLG(NG),IVEGTFLG(NG),ISOILFLG(NG)  &
            ,NOFILFLG(NG),NDVIFLG(NG),NG=1,NGRIDS)

101  FORMAT(A1,'   NNXP=',I4,'       NNYP=',I4,'       NNZP=',I4  &
     ,'    NXTNEST=',I4,'    NSTRATX=',I4,999(A1,/,I13,4I16))
102  FORMAT(A1,'NSTRATY=',I4,'     IDIFFK=',I4,'    NNDTRAT=',I4  &
     ,'    NNQPARM=',I4,'     NINEST=',I4,999(A1,/,I13,4I16))
103  FORMAT(A1,' NJNEST=',I4,'     NKNEST=',I4,'    NNSTTOP=',I4  &
     ,'    NNSTBOT=',I4,'   ITOPTFLG=',I4,999(A1,/,I13,4I16))
104  FORMAT(A1,'ISSTFLG=',I4,'   IVEGTFLG=',I4,'   ISOILFLG=',I4  &
     ,'   NOFILFLG=',I4,'    NDVIFLG=',I4,999(A1,/,I13,4I16))

PRINT*, ' '
WRITE(6,201)NGRIDS,NESTZ1,NESTZ2,INITIAL,IOUTPUT,NUDLAT,if_adap
WRITE(6,202)INITFLD,IHTRAN,NACOUST,NTOPSMTH
WRITE(6,203)IUPDSST,IZFLAT,IMPL,ICORFLG,NSLCON,IBND
WRITE(6,204)JBND,LSFLG,NFPT,IDELTAT,ISWRTYP,ILWRTYP
WRITE(6,205)LONRAD,IMONTH1,IDATE1,IYEAR1,ITIME1,ISFCL
WRITE(6,206)NVGCON,NPLT,IPSFLG,ITSFLG,IRTSFLG
WRITE(6,207)IUSFLG,MKCOLTAB,NZG,NZS,IUPDNDVI
WRITE(6,208)NPATCH,NVEGPAT,LEVEL,ICLOUD
WRITE(6,209)IRAIN,IPRIS,ISNOW,IAGGR,IGRAUP
WRITE(6,210)IHAIL,NADDSC,IADVL,IADVF

201  FORMAT('  NGRIDS=',I4,'     NESTZ1=',I4,'     NESTZ2=',I4  &
   ,'    INITIAL=',I4,'    IOUTPUT=',I4,'     NUDLAT=',I4,'     IF_ADAP=',I4)
202  FORMAT(' INITFLD=',I4,'     IHTRAN=',I4  &
   ,'    NACOUST=',I4,'   NTOPSMTH=',I4)
203  FORMAT(' IUPDSST=',I4,'     IZFLAT=',I4,'       IMPL=',I4  &
   ,'    ICORFLG=',I4,'     NSLCON=',I4,'       IBND=',I4)
204  FORMAT('    JBND=',I4,'      LSFLG=',I4,'       NFPT=',I4  &
   ,'    IDELTAT=',I4,'    ISWRTYP=',I4,'    ILWRTYP=',I4)
205  FORMAT('  LONRAD=',I4,'    IMONTH1=',I4,'     IDATE1=',I4  &
   ,'     IYEAR1=',I4,'     ITIME1=',I4,'      ISFCL=',I4)
206  FORMAT('  NVGCON=',I4,'       NPLT=',I4,'     IPSFLG=',I4  &
   ,'     ITSFLG=',I4,'    IRTSFLG=',I4)
207  FORMAT('  IUSFLG=',I4,'   MKCOLTAB=',I4,'        NZG=',I4  &
   ,'        NZS=',I4,'   IUPDNDVI=',I4)
208  FORMAT('  NPATCH=',I4,'    NVEGPAT=',I4,'      LEVEL=',I4  &
   ,'     ICLOUD=',I4)
209  FORMAT('   IRAIN=',I4,'      IPRIS=',I4,'      ISNOW=',I4  &
   ,'      IAGGR=',I4,'     IGRAUP=',I4)
210  FORMAT('   IHAIL=',I4,'     NADDSC=',I4,'      IADVL=',I4  &
   ,'      IADVF=',I4)

PRINT*, ' '
WRITE(6,301)(' ',TOPTENH(NG),TOPTWVL(NG),CENTLAT(NG),NG=1,NGRIDS)
WRITE(6,302)(' ',CENTLON(NG),CSX(NG),CSZ(NG),NG=1,NGRIDS)
WRITE(6,303)(' ',XKHKM(NG),ZKHKM(NG),AKMIN(NG),NG=1,NGRIDS)
WRITE(6,304)(' ',GRIDU(NG),GRIDV(NG),NG=1,NGRIDS)

301  FORMAT(A1,'TOPTENH=',E12.5,'        TOPTWVL=',E12.5  &
   ,'        CENTLAT=',E12.5,999(A1,/,E21.5,2E28.5))
302  FORMAT(A1,'CENTLON=',E12.5,'            CSX=',E12.5  &
   ,'            CSZ=',E12.5,999(A1,/,E21.5,2E28.5))
303  FORMAT(A1,'  XKHKM=',E12.5,'          ZKHKM=',E12.5  &
   ,'          AKMIN=',E12.5,999(A1,/,E21.5,2E28.5))
304  FORMAT(A1,'  GRIDU=',E12.5,'          GRIDV=',E12.5  &
   ,999(A1,/,E21.5,E28.5))

PRINT*, ' '

WRITE(6,401)TIMMAX
WRITE(6,402)frqstate(1),FRQPRT,TNUDLAT
WRITE(6,403)TNUDTOP,TNUDCENT,ZNUDTOP
WRITE(6,404)DTLONG,DELTAX,DELTAY
WRITE(6,405)POLELAT,POLELON,DELTAZ
WRITE(6,406)DZRAT,DZMAX,SSPCT
WRITE(6,407)CPHAS,DISTIM,RADFRQ
WRITE(6,408)CONFRQ,WCLDBS
WRITE(6,410)PCTLCON,ZROUGH,ALBEDO
WRITE(6,411)SEATMP,DTHCON,DRTCON
WRITE(6,412)CPARM,RPARM,PPARM
WRITE(6,413)SPARM,APARM,GPARM
WRITE(6,414)HPARM

401  FORMAT('   TIMMAX=',E12.5)
402  FORMAT('   FRQSTATE=',E12.5,'         FRQPRT=',E12.5  &
,'        TNUDLAT=',E12.5)
403  FORMAT('  TNUDTOP=',E12.5,'       TNUDCENT=',E12.5  &
,'        ZNUDTOP=',E12.5)
404  FORMAT('   DTLONG=',E12.5,'         DELTAX=',E12.5  &
,'         DELTAY=',E12.5)
405  FORMAT('  POLELAT=',E12.5,'        POLELON=',E12.5  &
,'         DELTAZ=',E12.5)
406  FORMAT('    DZRAT=',E12.5,'          DZMAX=',E12.5  &
,'          SSPCT=',E12.5)
407  FORMAT('    CPHAS=',E12.5,'         DISTIM=',E12.5  &
,'         RADFRQ=',E12.5)
408  FORMAT('   CONFRQ=',E12.5,'         WCLDBS=',E12.5)
410  FORMAT('  PCTLCON=',E12.5,'         ZROUGH=',E12.5  &
,'         ALBEDO=',E12.5)
411  FORMAT('   SEATMP=',E12.5,'         DTHCON=',E12.5  &
,'         DRTCON=',E12.5)
412  FORMAT('    CPARM=',E12.5,'          RPARM=',E12.5  &
,'          PPARM=',E12.5)
413  FORMAT('    SPARM=',E12.5,'          APARM=',E12.5  &
,'          GPARM=',E12.5)
414  FORMAT('    HPARM=',E12.5)

PRINT*, ' '
WRITE(6,501)(' ',IPLFLD(NP),PLFMT(NP),IXSCTN(NP)  &
                ,ISBVAL(NP),NP=1,NPLT)

501  FORMAT(A1,' IPLFLD=',A10,'   PLFMT=',A10  &
       ,'   IXSCTN=',I2,'   ISBVAL=',I4  &
       ,999(A1,/,9X,A10,9X,A10,I12,I14))

PRINT*, ' '
WRITE(6,601)(' ',ITOPTFN(M),M=1,NGRIDS)
WRITE(6,602)(' ',ISSTFN(M),M=1,NGRIDS)
WRITE(6,603)(' ',IVEGTFN(M),M=1,NGRIDS)
WRITE(6,604)(' ',ISOILFN(M),M=1,NGRIDS)
WRITE(6,605)(' ',NDVIFN(M),M=1,NGRIDS)
WRITE(6,606) ' ',trim(COLTABFN)
WRITE(6,607) ' ',trim(VARFPFX)
WRITE(6,608) ' ',trim(SSTFPFX)
WRITE(6,609) ' ',trim(SSTFPFX)

601  FORMAT(A1,'  ITOPTFN=',A40,999(A1,/,11X,A40))
602  FORMAT(A1,'   ISSTFN=',A40,999(A1,/,11X,A40))
603  FORMAT(A1,'  IVEGTFN=',A40,999(A1,/,11X,A40))
604  FORMAT(A1,'  ISOILFN=',A40,999(A1,/,11X,A40))
605  FORMAT(A1,'   NDVIFN=',A40,999(A1,/,11X,A40))
606  FORMAT(A1,' COLTABFN=',A)
607  FORMAT(A1,'  VARFPFX=',A)
608  FORMAT(A1,'  SSTFPFX=',A)
609  FORMAT(A1,' NDVIFPFX=',A)

PRINT*, ' '
WRITE(6,701)EXPNME
PRINT*, ' '
WRITE(6,702)HFILIN
WRITE(6,704)AFILEPREF
PRINT*, ' '
WRITE(6,705)RUNTYPE,TIMEUNIT

701  FORMAT('  EXPNME=',A40)
702  FORMAT('  HFILIN=',A40)
704  FORMAT(' AFILEPREF=',A40)
705  FORMAT(' RUNTYPE=',A10,'      TIMEUNIT=',A3)

PRINT*, ' '
WRITE(6,901)(' ',SLMSTR(K),SLZ(K),STGOFF(K),K=1,NZG)

901  FORMAT(A1,' SLMSTR=',F6.2,'      SLZ=',F7.3,'      STGOFF=',F8.2  &
     ,999(A1,/,F15.2,F17.3,F21.2))

PRINT*, ' '
WRITE(6,1001)(ZZ(K),K=1,NNZP(1))

1001  FORMAT('ZZ=',8F9.1,/,(F12.1,7F9.1))

WRITE(6,1101)(NSTRATZ1(K),K=1,NNZP(1))
1101 FORMAT(/,'NSTRATZ1=',(t9,23i3) )

WRITE(6,1201)(NSTRATZ2(K),K=1,NNZP(1))
1201 FORMAT(/,'NSTRATZ2=',(t9,23i3) )

write(6,1301)(gnu(k),k=1,7)
1301 format(/,'GNU=',(t9,7f5.2))

RETURN
END

!*******************************************************************************

FUNCTION LC(STR)

CHARACTER*(*) STR

L=LEN(STR)
DO NC=L,1,-1
   IF(STR(NC:NC).NE.' '.AND.STR(NC:NC).NE.CHAR(0))THEN
      LC=NC
      RETURN
   ENDIF
ENDDO
LC=1
RETURN
END

!*******************************************************************************

SUBROUTINE NAMEIN(IUNIT,GROUP,IFATAL)

! This routine is called by routines INITLZ, CONSTAT, and ARRSND
! to input the values for the NAMELIST specified by the character stri
! GROUP from input unit IUNIT.
implicit none
character(len=*) :: group
integer :: ifatal,iunit

integer, parameter :: maxrec=1000,linvar=10,maxvar=100,maxval=300
character(len=20) :: varn
character(len=80) :: line,linew,value(maxval),tokens(80)
integer :: nrflag,nfatal
common/nread/nrflag,nfatal

integer :: nvalue,nvarn,nr,ncw,nt,ntok,isub1,isub2,int
real :: fnum
integer, external :: letter,number,letquo

rewind iunit
NFATAL=IFATAL
NRFLAG=0
NVALUE=0
NVARN=0
CALL FINDGR(IUNIT,GROUP,MAXREC)

IF(NRFLAG.EQ.1.AND.IFATAL.EQ.1) STOP 'NAMEIN'
DO 10 NR=1,MAXREC
   LINE(1:80)=''
   READ(IUNIT,'(A80)',END=100)LINE
   LINEW(1:80)=''
   CALL STRIP(LINE,LINEW,NCW)
   NCW=MAX(NCW,1)
   CALL TOKNZE(LINEW,NCW,TOKENS,NTOK)
   IF(LINEW(1:NCW).EQ.'$END') GOTO 100
   NT=1
   20 CONTINUE
      IF(NT.GT.NTOK) GOTO 10
      IF(LETTER(TOKENS(NT)).EQ.1) THEN
         IF(NVARN.GT.0) CALL NVTRAN(GROUP,VARN,ISUB1,ISUB2,VALUE,NVALUE)
         NVALUE=0
         ISUB1=0
         ISUB2=0
         VARN=TOKENS(NT)
         NVARN=NVARN+1
         NT=NT+1
         IF(TOKENS(NT).EQ.'(') THEN
            NT=NT+1
            CALL CH2INT(TOKENS(NT),ISUB1)
            NT=NT+1
            IF(TOKENS(NT).EQ.',') THEN
               NT=NT+1
               CALL CH2INT(TOKENS(NT),ISUB2)
               NT=NT+1
            ENDIF
         ENDIF
      ELSEIF(NUMBER(TOKENS(NT)).EQ.1.OR.LETQUO(TOKENS(NT)).EQ.1) THEN
          NVALUE=NVALUE+1
          VALUE(NVALUE)=TOKENS(NT)
      ENDIF
      NT=NT+1
   GOTO 20
10 CONTINUE

100 CONTINUE
CALL NVTRAN(GROUP,VARN,ISUB1,ISUB2,VALUE,NVALUE)
VARN='$END'
CALL NVFILLM(GROUP,VARN,ISUB1,ISUB2,INT,FNUM,LINEW(1:NCW),NR)

RETURN
END

!*******************************************************************************

SUBROUTINE NVTRAN(GROUP,VARN,ISUB1,ISUB2,VALUE,NVALUE)

! This routine converts a variable value(s) (VALUE) read in as a
! character string(s) to the proper type (integer, real, or character)
! and assigns it (them) to the storage location(s) corresponding to
! the NAMELIST variable VARN(ISUB1,ISUB2).  GROUP is the NAMELIST
! group name.  NVALUE is the number of values to be assigned.
implicit none
integer :: ISUB1,ISUB2,NVALUE
CHARACTER(len=*) :: GROUP,VARN,VALUE(*)
character(len=80) :: CHVAL

integer :: nv,int,ncw
real :: fnum
integer, external :: letint,letquo

ncw=1

IF(LETINT(VARN).EQ.1) THEN
   DO NV=1,NVALUE
      IF(LETQUO(VALUE(NV)).EQ.0) THEN
         CALL CH2INT(VALUE(NV),INT)
        CALL NVFILLM(GROUP,VARN,ISUB1,ISUB2,INT,FNUM,CHVAL(1:NCW),NV)
      ELSE
         CALL CH2CH(VALUE(NV),CHVAL,NCW)
         CALL NVFILLm(GROUP,VARN,ISUB1,ISUB2,INT,FNUM,CHVAL(1:NCW),NV)
      ENDIF
   ENDDO
ELSE
   DO NV=1,NVALUE
      IF(LETQUO(VALUE(NV)).EQ.0) THEN
         CALL CH2REAL(VALUE(NV),FNUM)
         CALL NVFILLm(GROUP,VARN,ISUB1,ISUB2,INT,FNUM,CHVAL(1:NCW),NV)
      ELSE
         CALL CH2CH(VALUE(NV),CHVAL,NCW)
         CALL NVFILLm(GROUP,VARN,ISUB1,ISUB2,INT,FNUM,CHVAL(1:NCW),NV)
      ENDIF
   ENDDO
ENDIF

RETURN
END
